--- ln.lua - warpper for 'fsutil hardlink create'

if nyaos.create_object then
    function nyaos.command.ln(...)
        local src={...}
        if src[1] and src[1] == "-s" and nyaos.command.lnk then
            table.remove(src,1)
            return nyaos.command.lnk( table.unpack(src) )
        end

        local fsObj=nyaos.create_object('Scripting.FileSystemObject')
        local dst=table.remove(src)

        if #src <= 0 then
            print("Usage: ln TARGET LINK_NAME")
            print("       ln TARGET... DIRECTORY")
            if nyaos.command.lnk then
                print("       ln -s TARGET ... SHORTCUT")
            end
            return 
        end

        local err=false
        for i,src1 in ipairs(src) do
            if fsObj:FolderExists(src1) then
                print("ln: `" .. src1 .. 
                      "': hard link not allowed for directory")
                err=true
            end
        end
        if err then
            return 1
        end

        for i,src1 in ipairs(src) do
            local dst1=dst
            if fsObj:FolderExists(dst1) then
                dst1 = fsObj:BuildPath(dst1,fsObj:getFileName(src1))
            end

            nyaos.exec(string.format(
                'fsutil hardlink create "%s" "%s"' ,
                dst1 , src1 ) )
        end
    end
end
